/* RollingNumbers - animates from one number to another by scrolling its digits. */

#ifndef RollingNumbers_H
#define RollingNumbers_H

#include "BitmapText.h"

class RollingNumbers : public BitmapText
{
public:
	RollingNumbers();

	void LoadFromNode( const XNode* pNode );
	virtual RollingNumbers *Copy() const;

	virtual void Update( float fDeltaTime );

	void SetTargetNumber( float fTargetNumber );

	void UpdateText();

	//
	// Commands
	//
	virtual void PushSelf( lua_State *L );

private:
	// Loaded attributes
	//
	// Time between the call to SetTargetNumber and m_fCurrentNumber == 
	// m_fTargetNumber.  Used to calculate m_fScoreVelocity.
	float	m_fApproachSeconds;
	RString m_sFormat;

	//
	// Calculated
	//
	float	m_fCurrentNumber;	// currently showing this
	float	m_fTargetNumber;	// approach this
	float	m_fScoreVelocity;	// approach target at this speed
};

#endif

/*
 * (c) 2001-2004 Chris Danford
 * All rights reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, provided that the above
 * copyright notice(s) and this permission notice appear in all copies of
 * the Software and that both the above copyright notice(s) and this
 * permission notice appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF
 * THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR HOLDERS
 * INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL INDIRECT
 * OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
 * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */
