#ifndef INPUT_HANDLER_XBOX_H
#define INPUT_HANDLER_XBOX_H

#include "InputHandler.h"

#include <xtl.h>

#define NUM_PORTS 4

class InputHandler_Xbox: public InputHandler
{
	HANDLE joysticks[NUM_JOYSTICKS];
	XINPUT_GAMEPAD lastState[NUM_JOYSTICKS];

public:
	void Update();
	InputHandler_Xbox();
	~InputHandler_Xbox();
	void GetDevicesAndDescriptions( vector<InputDeviceInfo>& vDevicesOut );

private:
	void getHandles();
};
#define USE_INPUT_HANDLER_XBOX
REGISTER_INPUT_HANDLER_CLASS( Xbox );

#endif

/*
 * (c) 2004 Ryan Dortmans
 * All rights reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, provided that the above
 * copyright notice(s) and this permission notice appear in all copies of
 * the Software and that both the above copyright notice(s) and this
 * permission notice appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF
 * THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR HOLDERS
 * INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL INDIRECT
 * OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
 * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */
